<script lang="ts" setup>
import { GlobalError, useAppStore } from '@/stores/app'
import { Modal } from 'flowbite'
import { onMounted, reactive } from 'vue'

const emit = defineEmits<{
  uploaded: []
}>()

const app = useAppStore()

let modal: Modal | null = null
const state = reactive({
  uploading: false,
  success: false,
  uploadProgress: 0.0,
  xhr: null as XMLHttpRequest | null,
  previewUrl: null as string | null,
  file: null as File | null
})

onMounted(() => {
  const $modalElement: HTMLElement | null = document.querySelector('#file-upload-modal')

  const modalOptions = {
    backdropClasses: 'bg-gray-900/50 dark:bg-gray-900/80 fixed inset-0 z-40'
  }

  if ($modalElement) {
    modal = new Modal($modalElement, modalOptions)
    modal.updateOnHide(() => {
      if (state.xhr != null) {
        state.xhr.abort()
        state.xhr = null
      }
    })
  }
})

function hideModal() {
  modal!.hide()
}

function onFileChanged($event: Event) {
  if (state.xhr != null) {
    state.xhr.abort()
    state.xhr = null
  }

  modal!.show()
  const target = $event.target as HTMLInputElement
  if (target && target.files && !!target.files[0]) {
    state.file = target.files[0]
    state.previewUrl = URL.createObjectURL(state.file)
    state.uploading = true
    state.success = false

    state.xhr = new XMLHttpRequest()
    state.xhr.upload.addEventListener('progress', (event) => {
      if (event.lengthComputable) {
        state.uploadProgress = Math.round((event.loaded / event.total) * 100)
        console.log(state.uploadProgress)
      }
    })
    state.xhr.addEventListener('loadend', () => {
      state.uploading = false
      state.success = state.xhr?.readyState === 4 && state.xhr?.status === 200
      if (state.success) {
        state.xhr = null
        emit('uploaded')
        if (!!modal && !modal.isHidden()) {
          modal!.hide()
        }
      } else {
        if (state.xhr?.status === 413) {
          app.setGlobalError(GlobalError.UploadTooLarge)
        } else if (state.xhr?.status === 400) {
          app.setGlobalError(GlobalError.ProfilePictureBadFormat)
        } else {
          app.setGlobalError(GlobalError.ActionFailedError)
        }
        modal?.hide()
      }
    })

    state.xhr.open('POST', '/api/user/profile-picture', true)
    state.xhr.setRequestHeader('Authorization', 'Bearer ' + app.sessionKey)

    const formData = new FormData()
    formData.set('file', target.files[0])
    formData.set('metadata', '{}')
    state.xhr.send(formData)
  }
}
</script>

<template>
  <div>
    <div class="flex gap-3">
      <input
        v-if="!state.success"
        class="block w-full text-sm text-gray-900 border border-gray-300 rounded-lg cursor-pointer bg-gray-50 dark:text-gray-400 focus:outline-none dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400"
        id="file_input"
        type="file"
        accept="image/png, image/jpeg"
        @change="onFileChanged"
      />
      <AppButton v-else>{{ $t('ui.update') }}</AppButton>
    </div>
    <p
      v-if="!state.success"
      class="mt-1 text-sm text-gray-500 dark:text-gray-300"
      id="file_input_help"
    >
      {{ $t('formProfilePicture.uploadRequirements') }}
    </p>

    <!-- Modal -->
    <div
      id="file-upload-modal"
      tabindex="-1"
      class="hidden overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 justify-center items-center w-full md:inset-0 h-[calc(100%-1rem)] max-h-full"
    >
      <div class="relative p-4 w-full max-w-md max-h-full">
        <div class="relative bg-white rounded-lg shadow dark:bg-gray-700">
          <button
            type="button"
            class="absolute top-3 end-2.5 text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm w-8 h-8 ms-auto inline-flex justify-center items-center dark:hover:bg-gray-600 dark:hover:text-white"
            @click="hideModal"
          >
            <svg
              class="w-3 h-3"
              aria-hidden="true"
              xmlns="http://www.w3.org/2000/svg"
              fill="none"
              viewBox="0 0 14 14"
            >
              <path
                stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="m1 1 6 6m0 0 6 6M7 7l6-6M7 7l-6 6"
              />
            </svg>
          </button>
          <div class="p-4 md:p-5">
            <div class="mb-4 flex">
              <svg
                class="w-7 h-7 me-1 text-gray-400 dark:text-gray-500"
                aria-hidden="true"
                xmlns="http://www.w3.org/2000/svg"
                width="24"
                height="24"
                fill="none"
                viewBox="0 0 24 24"
              >
                <path
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  d="M12 5v9m-5 0H5a1 1 0 0 0-1 1v4a1 1 0 0 0 1 1h14a1 1 0 0 0 1-1v-4a1 1 0 0 0-1-1h-2M8 9l4-5 4 5m1 8h.01"
                />
              </svg>
              <h3 class="text-xl font-bold text-gray-900 dark:text-white">
                {{ $t('modalUpload.title') }}
              </h3>
            </div>

            <div class="my-3 flex justify-center">
              <img alt="" :src="state.previewUrl as string | undefined" class="rounded-lg h-32" />
            </div>

            <div class="flex justify-between mb-1 text-gray-500 dark:text-gray-400">
              <span v-if="!!state.file" class="text-base font-normal"
                >{{ (state.file!.size / 1024 / 1024).toFixed(2) }} MiB</span
              >
              <span class="text-base font-semibold text-gray-900 dark:text-white"
                >{{ state.uploadProgress }} %</span
              >
            </div>

            <div class="w-full bg-gray-200 rounded-full h-2.5 dark:bg-gray-600">
              <div
                :class="`${state.success ? 'bg-green-500' : 'bg-blue-500'} h-2.5 rounded-full`"
                :style="`width: ${state.uploadProgress}%`"
              ></div>
            </div>

            <!-- Modal footer -->
            <div class="mt-6">
              <AppButton @click="hideModal">{{
                state.success ? $t('ui.close') : $t('ui.cancel')
              }}</AppButton>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
